//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#include "L2Gen.h"

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


bool TForm1::bmpSukurti()
{
        header = new unsigned char[54];
        for(int i = 0; i < 54; i++)
                header[i] = 0;
        dataSize = labIlgis * labPlotis * 3;
        visasDydis = 54 + dataSize;
     
        
/*      BMP HEADERIS (54 baitai)
 0-1    unsigned short  id;             //Characters to identify bitmap
 2-5    unsigned int    size;           //Failo dydis baitais
 6-9    unsigned int    reserved;       //Reserved for later use
 10-13  unsigned int    offset;         //Offset from beginning of file to the beginning of the bitmap data
 14-17  unsigned int    header;         //Length of the bitmap info header
 18-21  unsigned int    width;          //Plotis
 22-25  unsigned int    height;         //Aukstis
 26-27  unsigned short  planes;         //Number of planes in this bitmap
 28-29  unsigned short  bpp;            //1 - monochrome  4 - 16 color  8 - 256 color  16 - 16bit high color  24 - 24bit true color  32 - 32bit true color
 30-33  unsigned int    compress;       //Suspaudimas: 0 - nera, 1 - rle 8-bit, 2 - rle 4-bit, 3 - bitfields
 34-37  unsigned int    dataSize;       //Size of the bitmap data in bytes
 38-41  unsigned int    hres;           //Horizontal resolution expressed in pixel per meter
 42-45  unsigned int    vres;           //Vertical resolution expressed in pixels per meter
 46-49  unsigned int    colors;         //Number of colors used by this bitmap
 50-53  unsigned int    impColors;      //Number of important colors
*/

        header[0] = 'B';
        header[1] = 'M';
        
        header[2] = visasDydis % 256;
        header[3] = (visasDydis % (256 * 256)) / 256;
        header[4] = (visasDydis % (256 * 256 * 256)) / (256 * 256);
        header[5] = visasDydis / (256 * 256 * 256);
        
        header[10] = 54;
        header[14] = 40;
        
        header[18] = labIlgis % 256;
        header[19] = (labIlgis % (256 * 256)) / 256;
        header[20] = (labIlgis% (256 * 256 * 256)) / (256 * 256);
        header[21] = labIlgis / (256 * 256 * 256);
        
        header[22] = labPlotis % 256;
        header[23] = (labPlotis % (256 * 256)) / 256;
        header[24] = (labPlotis % (256 * 256 * 256)) / (256 * 256);
        header[25] = labPlotis / (256 * 256 * 256);
        
        header[26] = 1;
        header[28] = 24;
        
        header[34] = dataSize % 256;
        header[35] = (dataSize % (256 * 256)) / 256;
        header[36] = (dataSize % (256 * 256 * 256)) / (256 * 256);
        header[37] = dataSize / (256 * 256 * 256);


        data = new unsigned char[dataSize];
        

        for(int n = 0; n < labPlotis; n++)
		        for(int m = 0; m < labIlgis; m++){
			            /*if(lab[n][m] == 0){
                             data[(n * labIlgis + m) * 3 + (n * 2)] = 0;
                             data[(n * labIlgis + m) * 3 + (n * 2) + 1] = 0;
                             data[(n * labIlgis + m) * 3 + (n * 2) + 2] = 0;
                        }             
                        else{
                             data[(n * labIlgis + m) * 3 + (n * 2)] = 255;
                             data[(n * labIlgis + m) * 3 + (n * 2) + 1] = 255;
                             data[(n * labIlgis + m) * 3 + (n * 2) + 2] = 255;
                        } 
                        if(m == labIlgis - 1){
                             data[(n * labIlgis + m) * 3 + (n * 2) + 3] = 0;
                             data[(n * labIlgis + m) * 3 + (n * 2) + 4] = 0;
                        }*/
                        if(lab[n][m] == 0){
                             data[(n * labIlgis + m) * 3] = 0;
                             data[(n * labIlgis + m) * 3 + 1] = 0;
                             data[(n * labIlgis + m) * 3 + 2] = 0;
                        }             
                        else{
                             data[(n * labIlgis + m) * 3] = 255;
                             data[(n * labIlgis + m) * 3 + 1] = 255;
                             data[(n * labIlgis + m) * 3 + 2] = 255;
                        }
               }
        data[(pradY * labIlgis + pradX) * 3] = 0;
        data[(pradY * labIlgis + pradX) * 3 + 1] = 0;
        data[(pradY * labIlgis + pradX) * 3 + 2] = 255;
        
        data[(iseY * labIlgis + iseX) * 3] = 0;
        data[(iseY * labIlgis + iseX) * 3 + 1] = 255;
        data[(iseY * labIlgis + iseX) * 3 + 2] = 0;
                    
        return true;
}


bool TForm1::SkaicLang()
{
        unsigned int sum = 0;
        labLangViso = 0;
        if(CheckBox1->Checked){
                for(unsigned int i = 0; i < bmp.dataSize; i++){
                        sum += *(bmp.data + i);
                        if(i % 3 == 2){
                                if(sum > 384)
                                        labLangViso++;
                                sum = 0;
                        }
                }
                labLangViso = (int)labLangViso / 2.13;
        }
        else
                labLangViso = (int)((labIlgis * labPlotis - (labIlgis * 2) - (labPlotis * 2)) / 2.13);
}


bool TForm1::bmpSaugoti()
{
        //if(!yra toks failas)
        //        return false;
        FILE * failas;
        failas = fopen(pav, "w");
        fwrite(header, 54, 1, failas);
        fwrite(data, dataSize, 1, failas);
        fclose(failas);
        return true;
}


void TForm1::genLabBMP()
{
        unsigned int sk;
        for(int n = 0; n < labPlotis; n++)
		for(int m = 0; m < labIlgis; m++){
                        sk =   *(bmp.data + (n * labIlgis * 3) + (m * 3))
                             + *(bmp.data + (n * labIlgis * 3) + (m * 3)+ 1)
                             + *(bmp.data + (n * labIlgis * 3) + (m * 3) + 2);
                        if(sk > 384)
                                sk = 5;
                        else
                                sk = 0;
                        if(RadioButton2->Checked &&
                          *(bmp.data + (n * labIlgis * 3) + (m * 3)) == spalvaAugaB &&
                          *(bmp.data + (n * labIlgis * 3) + (m * 3) + 1) == spalvaAugaG &&
                          *(bmp.data + (n * labIlgis * 3) + (m * 3) + 2) == spalvaAugaR)
                                sk = 1;
			lab[n][m] = sk;
                }
}

void TForm1::genLabValyti()
{
        int n, m;
     for(n = 0; n < labPlotis; n++)
		for(m = 0; m < labIlgis; m++)
			lab[n][m] = 1;
     for(n = 1; n < labPlotis - 1; n++)
		for(m = 1; m < labIlgis - 1; m++)
			lab[n][m] = 0;
}

void TForm1::genLabLaisvi(unsigned int x, unsigned int y, bool *laisva)	//Funkcija suranda laisvas kryptis
{
	*(laisva + 0) = false;
	*(laisva + 1) = false;
	*(laisva + 2) = false;
	*(laisva + 3) = false;

	if((lab[y - 2][x - 1] == 0) &&		//Ar laisva i virsu?
		(lab[y - 2][x] == 0) &&
		(lab[y - 2][x + 1] == 0) &&
		(lab[y - 1][x - 1] == 0) &&
		(lab[y - 1][x] == 0) &&
		(lab[y - 1][x + 1] == 0) &&
		(y > 1))
		*(laisva + 0) = true;

	if((lab[y - 1][x + 2] == 0) &&		//Ar laisva i desine?
		(lab[y][x + 2] == 0) &&
		(lab[y + 1][x + 2] == 0) &&
		(lab[y - 1][x + 1] == 0) &&
		(lab[y][x + 1] == 0) &&
		(lab[y + 1][x + 1] == 0) &&
		(x < labIlgis - 2))
		*(laisva + 1) = true;

	if((lab[y + 2][x - 1] == 0) &&		//Ar laisva zemyn?
		(lab[y + 2][x] == 0) &&
		(lab[y + 2][x + 1] == 0) &&
		(lab[y + 1][x - 1] == 0) &&
		(lab[y + 1][x] == 0) &&
		(lab[y + 1][x + 1] == 0) &&
		(y < labPlotis - 2))
		*(laisva + 2) = true;

	if((lab[y - 1][x - 2] == 0) &&		//Ar laisva i kaire?
		(lab[y][x - 2] == 0) &&
		(lab[y + 1][x - 2] == 0) &&
		(lab[y - 1][x - 1] == 0) &&
		(lab[y][x - 1] == 0) &&
		(lab[y + 1][x - 1] == 0) &&
		(x > 1))
		*(laisva + 3) = true;
}

bool TForm1::genLabYraLaisvu(unsigned int x, unsigned int y)	//Funkcija iesko, ar yra laisvu krypciu
{
	if((lab[y - 2][x - 1] == 0) &&		//Ar laisva i virsu?
		(lab[y - 2][x] == 0) &&
		(lab[y - 2][x + 1] == 0) &&
		(lab[y - 1][x - 1] == 0) &&
		(lab[y - 1][x] == 0) &&
		(lab[y - 1][x + 1] == 0) &&
		(y > 1))
		return true;

	if((lab[y - 1][x + 2] == 0) &&		//Ar laisva i desine?
		(lab[y][x + 2] == 0) &&
		(lab[y + 1][x + 2] == 0) &&
		(lab[y - 1][x + 1] == 0) &&
		(lab[y][x + 1] == 0) &&
		(lab[y + 1][x + 1] == 0) &&
		(x < labIlgis - 2))
		return true;

	if((lab[y + 2][x - 1] == 0) &&		//Ar laisva zemyn?
		(lab[y + 2][x] == 0) &&
		(lab[y + 2][x + 1] == 0) &&
		(lab[y + 1][x - 1] == 0) &&
		(lab[y + 1][x] == 0) &&
		(lab[y + 1][x + 1] == 0) &&
		(y < labPlotis - 2))
		return true;

	if((lab[y - 1][x - 2] == 0) &&		//Ar laisva i kaire?
		(lab[y][x - 2] == 0) &&
		(lab[y + 1][x - 2] == 0) &&
		(lab[y - 1][x - 1] == 0) &&
		(lab[y][x - 1] == 0) &&
		(lab[y + 1][x - 1] == 0) &&
		(x > 1))
		return true;

	return false;
}

void TForm1::genLabIse(unsigned int x, unsigned int y)		//Langeli (x, y) sujungia su isejimu
{
	if(x == iseX || y == iseY)		//Langeliai lieciasi krastine?
		return;

	if((lab[y + y - iseY][iseX] == 0) &&	//Langeliai lieciasi kampais?
		(lab[y + y - iseY][iseX + iseX - x] == 0))	
		lab[y][iseX] = 1;

	else lab[iseY][x] = 1;
}

bool TForm1::genLabYraIsejimas()
{
	if(lab[iseY - 1][iseX - 1] == 0 &&
		lab[iseY - 1][iseX] == 0 &&
		lab[iseY - 1][iseX + 1] == 0 &&
		lab[iseY][iseX - 1] == 0 &&
		lab[iseY][iseX + 1] == 0 &&
		lab[iseY + 1][iseX - 1] == 0 &&
		lab[iseY + 1][iseX] == 0 &&
		lab[iseY + 1][iseX + 1] == 0)
			return false;
	return true;
}

// 0 - vieta, i kuria gali augti labirintai
// 1 - vieta, is kur gali augti labirintai
// 2 - pradzia
// 3 - isejimas
void TForm1::genLab(unsigned int ilg, unsigned int plot, unsigned int segMaks, unsigned int seed)
{
	unsigned int n, m,
		dabX, dabY,
		kryptis,
		galEjimu,
		ejimas,
		seg;
	bool laisva[4];
	bool baigti1 = false, 
		baigti2 = false,
		rastasIse = false;
	
	srand(seed);

	dabX = pradX;
	dabY = pradY;
        labLangeliu = 0;
        
	lab[dabY][dabX] = 2;

	while(!baigti1){
		baigti2 = false;
		seg = 0;

                //Auginama saka is dabartines pozicijos
		while(!baigti2){
			if(genLabYraLaisvu(dabX, dabY)){
				genLabLaisvi(dabX, dabY, laisva);
				kryptis = rand() % 4;
				while(!laisva[kryptis])
					kryptis = rand() % 4;
				switch(kryptis){
					case 0: dabY--; break;
					case 1: dabX++; break;
					case 2: dabY++; break;
					case 3: dabX--; break;
				}
				lab[dabY][dabX] = 1;
                                if(labLangeliu < labLangViso)
                                        labLangeliu++;
                                ProgressBar1->Position = (int)(((float)labLangeliu / labLangViso) * 100);
				if(!rastasIse &&
					(dabX < iseX + 2) && (dabX > iseX - 2) && 
					(dabY < iseY + 2) && (dabY > iseY - 2)){
						genLabIse(dabX, dabY);
						lab[iseY][iseX] = 1;
						rastasIse = true;
						baigti2 = true;
				}
				seg++;
				if(seg > segMaks)
					baigti2 = true;
			}
			else baigti2 = true;
		}
		dabX = pradX;
		dabY = pradY;
		baigti2 = false;
		galEjimu = 0;

                //Ieskoma, kiek yra tasku, is kuriu gali augti saka
		for(n = 2; (n < labPlotis - 2) && !baigti2; n++)
			for(m = 2; (m < labIlgis - 2) && !baigti2; m++)
				if(lab[n][m] == 1 && genLabYraLaisvu(m, n) && !(m == iseX && n == iseY)){
					galEjimu++;
				}
		if(galEjimu == 0)
			baigti1 = true;

                //Isrenkamas random taskas
		else{
			ejimas = rand() % galEjimu + 1;
			galEjimu = 0;
			for(n = 2; (n < labPlotis - 2) && !baigti2; n++)
			for(m = 2; (m < labIlgis - 2) && !baigti2; m++)
				if(lab[n][m] == 1 && genLabYraLaisvu(m, n) && !(m == iseX && n == iseY)){
					galEjimu++;
					if(ejimas == galEjimu){
						dabX = m;
						dabY = n;
						baigti2 = true;
					}
				}
		}
	}
	lab[iseY][iseX] = 3;
	labYraIsejimas = genLabYraIsejimas();
        ProgressBar1->Position = 100;
}

void __fastcall TForm1::Button1Click(TObject *Sender)
{
        int i;
        labIlgis = StrToInt(Edit1->Text);
        if(labIlgis < 6) labIlgis = 6;
        if(labIlgis > LAB_MAX) labIlgis = LAB_MAX;

        labPlotis = StrToInt(Edit2->Text);
        if(labPlotis < 6) labPlotis = 6;
        if(labPlotis > LAB_MAX) labPlotis = LAB_MAX;

        if(CheckBox1->Checked){
                if(!FileExists(Edit10->Text))
                        ShowMessage("Failas " + Edit10->Text + " nerastas");
                else{
                        bmp.uzkrauti(Edit10->Text.c_str());
                        labIlgis = bmp.plotis;
                        labPlotis = bmp.aukstis;
                }
        }

        Edit1->Text = IntToStr(labIlgis);
        Edit2->Text = IntToStr(labPlotis);

        labSunk = StrToInt(Edit3->Text);
        if(labSunk < 1) labSunk = 1;
        Edit3->Text = IntToStr(labSunk);

        labSeed = StrToInt(Edit4->Text);
        if(labSeed < 1) labSeed = 1;
        Edit4->Text = IntToStr(labSeed);

        pradX = StrToInt(Edit6->Text);
        if(pradX < 2) pradX = 2;
        if(pradX > labIlgis - 3) pradX = labIlgis - 3;
        Edit6->Text = IntToStr(pradX);
        pradY = labPlotis - StrToInt(Edit7->Text);
        if(pradY < 2) pradY = 2;
        if(pradY > labPlotis - 3) pradY = labPlotis - 3;
        Edit7->Text = IntToStr(pradY);

        iseX = StrToInt(Edit8->Text);
        if(iseX < 2) iseX = 2;
        if(iseX > labIlgis - 3) iseX = labIlgis - 3;
        Edit8->Text = IntToStr(iseX);
        iseY = labPlotis - StrToInt(Edit9->Text);
        if(iseY < 2) iseY = 2;
        if(iseY > labPlotis - 3) iseY = labPlotis - 3;
        Edit9->Text = IntToStr(iseY);

        spalvaAugaR = StrToInt(Edit11->Text);
        spalvaAugaG = StrToInt(Edit12->Text);
        spalvaAugaB = StrToInt(Edit13->Text);

        strcpy(pav, Edit5->Text.c_str());
        labLangeliu = 0;
        ProgressBar1->Position = 0;

        genLabValyti();
        if(CheckBox1->Checked)
                genLabBMP();

        Button1->Caption = "Generuojama...";
        SkaicLang();
        genLab(labIlgis, labPlotis, labSunk, labSeed);
        bmpSukurti();
        bmpSaugoti();
        Button1->Caption = "Baigta!";
        if(!labYraIsejimas)
                MessageBox(NULL, "Isejimas nepasiektas!", "!!!", MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
        SYSTEMTIME SystemTime;
        GetLocalTime(&SystemTime);
        srand(SystemTime.wSecond * SystemTime.wMilliseconds);
        labSeed = (rand() % 1000) * 1000 + (rand() % 1000);
        Edit4->Text = IntToStr(labSeed);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
        if(CheckBox1->Checked == false){
                Button2->Enabled = true;
                Edit1->Enabled = true;
                Edit2->Enabled = true;
                Edit3->Enabled = true;
                Edit4->Enabled = true;

                RadioButton1->Enabled = false;
                RadioButton2->Enabled = false;
                Edit10->Enabled = false;
                Edit11->Enabled = false;
                Edit12->Enabled = false;
                Edit13->Enabled = false;
        }
        else{
                Button2->Enabled = false;
                Edit1->Enabled = false;
                Edit2->Enabled = false;
                Edit3->Enabled = false;
                Edit4->Enabled = false;

                Edit10->Enabled = true;
                RadioButton1->Enabled = true;
                RadioButton1->Checked = true;
                RadioButton2->Enabled = true;
        }
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button3Click(TObject *Sender)
{
        ShellExecute(NULL, "open", "http://ae.dar.lt",
                NULL, NULL, SW_SHOWNORMAL);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton1Click(TObject *Sender)
{
        Edit11->Enabled = false;
        Edit12->Enabled = false;
        Edit13->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton2Click(TObject *Sender)
{
        Edit11->Enabled = true;
        Edit12->Enabled = true;
        Edit13->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
        Button1->SetFocus();
        SYSTEMTIME SystemTime;
        GetLocalTime(&SystemTime);
        srand(SystemTime.wSecond * SystemTime.wMilliseconds);
        labSeed = (rand() % 1000) * 1000 + (rand() % 1000);
        Edit4->Text = IntToStr(labSeed);
}
//---------------------------------------------------------------------------

