//---------------------------------------------------------------------------

#ifndef L2GenH
#define L2GenH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <fstream.h>
#include <stdio.h>
#include <ComCtrls.hpp>
#include "bmp.h"
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TEdit *Edit1;
        TEdit *Edit2;
        TLabel *Label1;
        TLabel *Label2;
        TEdit *Edit3;
        TLabel *Label3;
        TEdit *Edit4;
        TLabel *Label4;
        TEdit *Edit5;
        TLabel *Label5;
        TButton *Button1;
        TEdit *Edit6;
        TLabel *Label6;
        TLabel *Label7;
        TEdit *Edit7;
        TLabel *Label8;
        TEdit *Edit8;
        TLabel *Label9;
        TLabel *Label10;
        TEdit *Edit9;
        TLabel *Label11;
        TButton *Button2;
        TLabel *Label12;
        TProgressBar *ProgressBar1;
        TLabel *Label13;
        TEdit *Edit10;
        TCheckBox *CheckBox1;
        TButton *Button3;
        TRadioButton *RadioButton1;
        TRadioButton *RadioButton2;
        TEdit *Edit11;
        TEdit *Edit12;
        TEdit *Edit13;
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall CheckBox1Click(TObject *Sender);
        void __fastcall Button3Click(TObject *Sender);
        void __fastcall RadioButton2Click(TObject *Sender);
        void __fastcall RadioButton1Click(TObject *Sender);
        void __fastcall FormActivate(TObject *Sender);
public:	// User declarations

#define LAB_MAX 2048

unsigned char   *header;        //Visas paveiksliuko headeris
unsigned char   *data;          //Paveiksliuko duomenys
unsigned int    plotis;
unsigned int    aukstis;
unsigned int    bpp;
unsigned int    dataSize;
unsigned int    visasDydis;
unsigned int    spalvaAugaR,     //Spalva, is kurios auga labirintai
                spalvaAugaG,
                spalvaAugaB;

unsigned int labLangDydis;	                      //Labirinto langelio dydis
unsigned int labIlgis, labPlotis;	          //Labirinto ilgis ir plotis langeliais
unsigned int labSunk;					              //Labirinto sunkumas
unsigned int labSeed;                                  //Seedas
unsigned char lab[LAB_MAX][LAB_MAX];	              //Labirintas
unsigned int iseX, iseY;				                  //Isejimo koordinates
unsigned int pradX, pradY;			                  //Zmogaus koordinates
bool labYraIsejimas;		              //Ar yra isejimas is labirinto?
unsigned int labLangeliu;
unsigned int labLangViso;
char pav[20];

bool SkaicLang();
void genLabBMP();
void genLabValyti();
void genLabLaisvi(unsigned int x, unsigned int y, bool *laisva);
bool genLabYraLaisvu(unsigned int x, unsigned int y);
void genLabIse(unsigned int x, unsigned int y);
bool genLabYraIsejimas();
void genLab(unsigned int ilg, unsigned int plot, unsigned int segMaks, unsigned int seed);

bool bmpSukurti();
bool bmpSaugoti();

bmpFailas bmp;


public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
