#ifndef _LINUX_
#include <windows.h>
#endif

#include <GL/gl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fstream>
using namespace std;

#include "bmp.h"

bool bmpFailas::uzkrauti(char *vardas)
{
        //if(!yra toks failas)
        //        return false;
        FILE *failas;
        header = new unsigned char[54];
        failas = fopen(vardas, "rb");
        fread(header, 54, 1, failas);
        //Apskaiciuojamos reiksmes
                if(!(header[0] == 'B' && header[1] == 'M'))
                        return false; //Klaida, failas nera BMP formato
                if(header[30] != 0)
                        return false; //Klaida, naudojamas suspaudimas
                if(header[46] != 0)
                        return false; //Klaida, naudojamos index spalvos
                plotis = header[19] * 256 + header[18];
                aukstis = header[23] * 256 + header[22];
                bpp = header[29] * 256 + header[28];
                dataSize = header[37]*256*256*256 + header[36]*256*256 + header[35]*256 + header[34];
        data = new unsigned char[dataSize];
        fread(data, dataSize, 1, failas);
        fclose(failas);
        return true;
}

void bmpFailas::rasyti()
{
        ofstream fr("r.txt", ios::trunc);
        fr<<"ID "<<header[0]<<header[1]<<endl;
        fr<<"plotis "<<plotis<<endl;
        fr<<"aukstis "<<aukstis<<endl;
        fr<<"bpp "<<bpp<<endl;
        fr<<"suspaudimas "<<(int)header[30]<<endl;
        fr<<"header size "<<(int)header[14]<<endl;
        fr<<"data size "<<dataSize<<endl;
        fr<<"colors "<<(int)header[46]<<endl;
        fr<<GL_UNSIGNED_BYTE;
        fr.close();
}

void bmpFailas::naikinti()
{
        delete[] header;
        delete[] data;
}
